/*
    Copyright (C) 2009 José Millán Soto <fid@gpul.org>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <kopeteplugin.h>
#include <kopeteonlinestatus.h>
#include <QString>
#include <QVariantList>
#include <QPair>

namespace Kopete {
    class MetaContact;
    class Contact;
}

class QDialog;

class ContactNotifier: public Kopete::Plugin {
    Q_OBJECT
    public:
        ContactNotifier(QObject *parent, const QVariantList &args);

    public slots:
        void slotOnlineStatusChanged(Kopete::MetaContact *contact,
          Kopete::OnlineStatus::StatusType status);
        void slotShowMessageDialog();
        void slotAcceptDialog();
        void slotRejectDialog();

    private:
        void loadConfig();
        void sendMessage(Kopete::Contact *c, QString messageText);
        QMap<QString, QString> m_messages;
        QMap<QDialog *, QString> m_dialogs;
        bool m_sendIfAway;

};
